#ifndef _GPG_CRYPTER_H_
#define _GPG_CRYPTER_H_


#include <gpgme.h>

/* Structure declaration */
typedef struct _application_data {
	gpgme_ctx_t CTX;
	gpgme_key_t key[2];
	int ASCIImode;
	GtkTextBuffer *buffer_plaintext;
	GtkTextBuffer *buffer_cipher;
	const gchar *passphrase;
	int num_keys; /* number of keys in key_array and key_string_array */
	GPtrArray *key_array; /* don't sort array */
	GPtrArray *key_string_array; /* don't sort array */
	GString *plaintext_file;
	GString *cipher_file;
}
application_data;

/* global app_data */
application_data *app_data;

void insert_combobox_row(gpointer data, gpointer user_data);
void combo_select_key(GtkWidget *widget, gpointer data);
void clear_plaintext_text_buffer(GtkWidget *widget, gpointer data);
void clear_cipher_text_buffer(GtkWidget *widget, gpointer data);
void change_chipher_file_asciimode(GtkWidget *widget, gpointer data);
void plaintext_file_changed(GtkWidget *widget, gpointer data);
void cipher_file_changed(GtkWidget *widget, gpointer data);
void plaintext_file_selector(GtkWidget *widget, gpointer data);
void cipher_file_selector(GtkWidget *widget, gpointer data);
void gpg_progress_callback(void *status, const char *what, int type, int current, int total);

int gpg_get_keys(application_data *app_data);
int gpg_init(application_data *app_data, gpgme_protocol_t proto);
int gpg_release(application_data *app_data);
gpgme_error_t gpg_passphrase_callback(void *HOOK, const char *UID_HINT, const char *PASSPHRASE_INFO, int PREV_WAS_BAD, int fd);


#endif
